#include "stdafx.h"
#include <cassert>
#include <fstream>
#include <iostream>
#include <iostream>
#include <boost/smart_ptr.hpp>
#include <boost/algorithm/string.hpp>
#include "tinyxml2.h"
#include "Fish_SouthSeaTreasureHuntEnterCFG.h"
#include "FileEncrypt.h"
std::auto_ptr<Fish_SouthSeaTreasureHuntEnterCFG> Fish_SouthSeaTreasureHuntEnterCFG::msSingleton(nullptr);

int Fish_SouthSeaTreasureHuntEnterCFG::GetCount()
{
	return (int)mMapData.size();
}

const Fish_SouthSeaTreasureHuntEnterCFGData* Fish_SouthSeaTreasureHuntEnterCFG::GetData(int ID)
{
	auto it = mMapData.find(ID);
	if (it != mMapData.end())
	{
		return &it->second;
	}
	return NULL;
}

boost::unordered_map<int, Fish_SouthSeaTreasureHuntEnterCFGData>& Fish_SouthSeaTreasureHuntEnterCFG::GetMapData()
{
	return mMapData;
}

void Fish_SouthSeaTreasureHuntEnterCFG::Reload()
{
	mMapData.clear();
	Load();
}

void Fish_SouthSeaTreasureHuntEnterCFG::Load(const std::string& path)
{
	std::ifstream readStream(path, std::ios::binary);
	if (!readStream.is_open())
	{
		assert(false);
		return;
	}
	readStream.seekg(0, std::ios::end);
	int fileSize = readStream.tellg();
	boost::shared_array<char> buffer(new char[fileSize+1]);
	buffer.get()[fileSize] = '\0';
	readStream.seekg(0, std::ios::beg);
	readStream.read(buffer.get(), fileSize);
	readStream.close();
	FileEncrypt::decryptBuffer( buffer, fileSize );
	tinyxml2::XMLDocument xmlDoc;
	auto result = xmlDoc.Parse(buffer.get(), fileSize);
	if (result != tinyxml2::XML_SUCCESS)
	{
		assert(false);
		return;
	}
	auto root = xmlDoc.RootElement();
	if (root == NULL)
	{
		assert(false);
		return;
	}
	auto element = root->FirstChildElement("Data");
	while (element != NULL)
	{
		Fish_SouthSeaTreasureHuntEnterCFGData data;
		data.mID = element->IntAttribute("ID");
		{
			const char* Enter1 = element->Attribute("Enter1");
			std::vector<std::string> vecEnter1;
			boost::split(vecEnter1, Enter1, boost::is_any_of(","));
			int temp;
			for (unsigned int i = 0; i < vecEnter1.size(); i++)
			{
				if (tinyxml2::XMLUtil::ToInt(vecEnter1[i].c_str(), &temp))
				{
					data.mEnter1.push_back(temp);
				}
			}
		}
		{
			const char* Enter2 = element->Attribute("Enter2");
			std::vector<std::string> vecEnter2;
			boost::split(vecEnter2, Enter2, boost::is_any_of(","));
			int temp;
			for (unsigned int i = 0; i < vecEnter2.size(); i++)
			{
				if (tinyxml2::XMLUtil::ToInt(vecEnter2[i].c_str(), &temp))
				{
					data.mEnter2.push_back(temp);
				}
			}
		}
		{
			const char* Rewards = element->Attribute("Rewards");
			std::vector<std::string> vecRewards;
			boost::split(vecRewards, Rewards, boost::is_any_of(","));
			int temp;
			for (unsigned int i = 0; i < vecRewards.size(); i++)
			{
				if (tinyxml2::XMLUtil::ToInt(vecRewards[i].c_str(), &temp))
				{
					data.mRewards.push_back(temp);
				}
			}
		}
		data.mName = element->Attribute("Name");
		if (mMapData.find(data.mID) != mMapData.end())std::cout <<"data refind:" << data.mID << std::endl;
		assert(mMapData.find(data.mID) == mMapData.end());
		mMapData.insert(std::make_pair(data.mID, data));
		element = element->NextSiblingElement();
	}
}

void Fish_SouthSeaTreasureHuntEnterCFG::Load()
{
	Load("../Config/Fish_SouthSeaTreasureHuntEnterCFG.xml");
}

Fish_SouthSeaTreasureHuntEnterCFG* Fish_SouthSeaTreasureHuntEnterCFG::GetSingleton()
{
	if (msSingleton.get() == nullptr)
	{
		msSingleton.reset(new Fish_SouthSeaTreasureHuntEnterCFG());
	}
	return msSingleton.get();
}
